package com.supermap.imobile.mdatacollector;

import java.util.ArrayList;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.os.Process;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

public class MyApplication extends Application {
		
		private static MyApplication sInstance = null;
        public static String RootPath ;
		private ArrayList<Activity> mActivities = new ArrayList<Activity>();
		
		@Override
		public void onCreate() {
			super.onCreate();
			RootPath = android.os.Environment.getExternalStorageDirectory().getAbsolutePath().toString();
			sInstance = this;
		
		}
		
		/**
		 * Get the current application object
		 * @return   Return MyApplication
		 */
		public static MyApplication getInstance() {
			return sInstance;
		}
		
		/**
		 * Toast display information
		 * @param strMsg   The string
		 */
		public  void showInfo(final String strMsg){
			Context context = getApplicationContext();
			View toastView = LayoutInflater.from(context).inflate(R.layout.toast_view, null);
			((TextView) toastView.findViewById(R.id.toast_Content)).setText(strMsg);
			Toast toast = new Toast(context);
			toast.setGravity(Gravity.CENTER, 0, 0);
			
			toast.setView(toastView);
			toast.show();
		}
		
		/**
		 * Register the Activity
		 * @param act  Activity object
		 */
		public void registerActivity(Activity act){
			mActivities.add(act);
		}
		
		/**
		 * Exit the application
		 */
		public void exit(){
		
			for(Activity act:mActivities){
				act.finish();
			}
			Process.killProcess(Process.myPid());
		}
		
		
}

